/*
 *  SXAsmCore.h
 *  llasm
 *
 *  Created by Britt Durbrow on 7/1/06.
 *  Copyright 2006 Rattlesnake Hill Softworks. All rights reserved.
 *
 */

#include <stdio.h>

typedef unsigned char u8;
typedef unsigned short u16;

#define MAX_INSTRUCTIONS 4096
#define MAX_LABELS 256

enum
{
	NO_OPS=0,
	L,
	FR,
	W,
	FR_W,
	W_FR,
	W_L,
	FR_B
};

struct opcode
{
	char mneumonic[8];
	int form;
	u16 opcode;
	u16 bMask;
	u16 fMask;
	u16 kMask;
	u16 kShift;
};

typedef struct opcode opcode;

struct label
{
	char name[32];
	unsigned int value;
};

typedef struct label label;

struct instruction
{
	struct opcode *opcode;
	u8 b;
	u8 f;
	u16 l;
	struct label *reference;
};

typedef struct instruction instruction;

extern opcode opcodes[];
extern opcode dwOpcode;

extern instruction instructions[MAX_INSTRUCTIONS];

extern label labels[MAX_LABELS];

extern unsigned int PC;
extern unsigned int MC;
extern unsigned int lastLabel;

extern opcode *findOpcode(char *mneumonic,int form);
extern label *findLabel(char *name);
extern void writeHex(FILE *f);
extern void writeList(FILE *f);
