%{
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "SXAsmCore.h"
#include "y.tab.h"

#define BUFFERSIZE 65536

int yylineno;

unsigned int axtoi(char *hexStg)
{
	int n = 0;		// position in string
	int m = 0;		// position in digit[] to shift
	int count;		// loop index
	unsigned int intValue = 0;	// integer value of hex string
	int digit[9];		// hold values to convert
	while ((n<8) && (hexStg[n]))
	{
		if (hexStg[n] > 0x29 && hexStg[n] < 0x40 )		//if 0 to 9
			digit[n] = hexStg[n] & 0x0f;				//convert to int
		else if (hexStg[n] >='a' && hexStg[n] <= 'f')	//if a to f
			digit[n] = (hexStg[n] & 0x0f) + 9;			//convert to int
		else if (hexStg[n] >='A' && hexStg[n] <= 'F')	//if A to F
			digit[n] = (hexStg[n] & 0x0f) + 9;			//convert to int
		else break;
		n++;
	};
	count = n;
	m = n - 1;
	n = 0;
	while(n < count) 
	{
		// digit[n] is value of hex digit at position n
		// (m << 2) is the number of positions to shift
		// OR the bits into return value
		intValue = intValue | (digit[n] << (m << 2));
		m--;	// adjust the position to set
		n++;	// next digit to process
	};
	return intValue;
};

int setInitialFile(FILE *f)
{
	yylineno=1;
	YY_BUFFER_STATE buf=yy_create_buffer(f,BUFFERSIZE);
	yy_switch_to_buffer(buf);
	return 0;
};

%}


%%
\<\< return SHL;
\>\> return SHR;
end	return END;
dw return DW;
ds return DS;
equ return EQU;
w	return 'w';
org return ORG;
forg return FORG;
$[0-9A-Fa-f]+ { yylval.longVal=axtoi(yytext+1); return NUMBER; };
[0-9]+ { yylval.longVal=atoi(yytext); return NUMBER; };
[a-zA-Z_][a-zA-Z0-9_]*\:	{
							strcpy(yylval.stringVal,yytext);
							yylval.stringVal[strlen(yylval.stringVal)-1]=0;
							return LABELDEF; 
						};
[a-zA-Z_][a-zA-Z0-9_]* { strcpy(yylval.stringVal,yytext); return NAME; };
\n { yylineno++; return EOL; };
[\t ] ;
;[!-}\t ]*\n { yylineno++; return EOL; };
. return (int)yytext[0];
%%
