#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "SXAsmCore.h"

extern int setInitialFile(FILE *f);
extern int parse();

int main (int argc, const char * argv[]) 
{
	extern int yydebug;
	int length;
	const char *ext;
	char filename[512];
	FILE *f;

	yydebug=1;
	
	if(argc!=2)
	{
		printf("Error: wrong number of arguments. Usage: llasm /path/to/asmfile.s\n\n");
		exit(1);
	};
	
	length=strlen(argv[1]);
	ext=((argv[1])+length)-2;
	
	if(length<3)
	{
		printf("Error: bad file name. Files must be of type asmfile.s\n\n");
		exit(1);
	};
		
	if(length>500)
	{
		printf("Error: file name too long.\n\n");
		exit(1);
	};
		
	if(strcmp(".s",ext)!=0)
	{
		printf("Error: bad file name. Files must be of type asmfile.s\n\n");
		exit(1);
	};

	
	f=fopen(argv[1],"r");
	if(f==NULL)
	{
		printf("Error: can't find or open source file.\n\n");
		exit(1);
	};
	
	
	setInitialFile(f);
	
	printf("\nAssembling file: %s\n",argv[1]);
	
	bzero(instructions,sizeof(instructions));
	parse();
	fclose(f);
	
	strncpy(filename,argv[1],length-2);
	strcpy(filename+(length-2),".lst");
	f=fopen(filename,"w");
	if(f==NULL)
	{
		printf("Error: can't open list file.\n\n");
		exit(1);
	};
	printf("Writing list file: %s\n",filename);
	writeList(f);
	fclose(f);
	
	
	strncpy(filename,argv[1],length-2);
	strcpy(filename+(length-2),".hex");
	f=fopen(filename,"w");
	if(f==NULL)
	{
		printf("Error: can't open hex file.\n\n");
		exit(1);
	};
	printf("Writing hex file: %s\n",filename);
	writeHex(f);
	fclose(f);
	
	printf("Done!\n");
    return 0;
};
