#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "mccCore.h"
#include "SXCodeGen.h"


extern int setInitialFile(FILE *f);
extern int parse();

int main (int argc, const char * argv[]) 
{
	extern int yydebug;
	int length;
	const char *ext;
	char filename[512];
	FILE *f;
	int argNum;
	
	
	yydebug=1;
	
	if(argc<4)
	{
		printf("Error: wrong number of arguments. Usage: mcc MCU speed /path/to/sourcefile1.mc </path/to/sourcefile2.mc>...\n\n");
		exit(1);
	};
	
	parsedProgram=malloc(sizeof(program));
	bzero(parsedProgram,sizeof(program));
	
	argNum=3;
	while(argNum<argc)
	{
		length=strlen(argv[argNum]);
		ext=((argv[argNum])+length)-3;
		
		if(length<4)
		{
			printf("Error: bad file name. Files must be of type sourcefile.mc\n\n");
			exit(1);
		};
			
		if(length>500)
		{
			printf("Error: file name too long.\n\n");
			exit(1);
		};
			
		if(strcmp(".mc",ext)!=0)
		{
			printf("Error: bad file name. Files must be of type sourcefile.mc\n\n");
			exit(1);
		};

		
		f=fopen(argv[argNum],"r");
		if(f==NULL)
		{
			printf("Error: can't find or open source file.\n\n");
			exit(1);
		};
		
		setInitialFile(f);
		
		printf("Parsing file: %s\n",argv[argNum]);
		parse();
		fclose(f);
		
		argNum++;
	};

	length=strlen(argv[3]);
	strncpy(filename,argv[3],length-3);
	strcpy(filename+(length-3),".mcc.s");
	f=fopen(filename,"w");
	if(f==NULL)
	{
		printf("Error: can't open output file.\n\n");
		exit(1);
	};
	printf("Compiling to file: %s\n",filename);
	
	compileSX(f);
	
	fclose(f);
	
	printf("Done!\n");
    return 0;
};
