%{
#include "mccCore.h"
#include "y.tab.h"
#include <string.h>

#define BUFFERSIZE 65536


unsigned int axtoi(char *hexStg)
{
	int n = 0;		// position in string
	int m = 0;		// position in digit[] to shift
	int count;		// loop index
	unsigned int intValue = 0;	// integer value of hex string
	int digit[9];		// hold values to convert
	while ((n<8) && (hexStg[n]))
	{
		if (hexStg[n] > 0x29 && hexStg[n] < 0x40 )		//if 0 to 9
			digit[n] = hexStg[n] & 0x0f;				//convert to int
		else if (hexStg[n] >='a' && hexStg[n] <= 'f')	//if a to f
			digit[n] = (hexStg[n] & 0x0f) + 9;			//convert to int
		else if (hexStg[n] >='A' && hexStg[n] <= 'F')	//if A to F
			digit[n] = (hexStg[n] & 0x0f) + 9;			//convert to int
		else break;
		n++;
	};
	count = n;
	m = n - 1;
	n = 0;
	while(n < count) 
	{
		// digit[n] is value of hex digit at position n
		// (m << 2) is the number of positions to shift
		// OR the bits into return value
		intValue = intValue | (digit[n] << (m << 2));
		m--;	// adjust the position to set
		n++;	// next digit to process
	};
	return intValue;
};

int setInitialFile(FILE *f)
{
	YY_BUFFER_STATE buf=yy_create_buffer(f,BUFFERSIZE);
	yy_switch_to_buffer(buf);
	return 0;
};


unsigned int abtoi(char *c)
{
	return 0;
};

int p;
int q;

%}


%%

[\n\t ]+		/* ignore white space */ ;

byte return BYTE;
if return IF;
while return WHILE;
repeat return REPEAT;
return return RETURN;
init return INIT;
vdx return VDX;

:= return ASSIGN;
\<\< return SHL;
\>\> return SHR;
\&\& return BAND;
\|\| return BOR;
\+\+ return INCOP;
\-\- return DECOP;

asm[ \t\n]*\{[!-z\t \n|]*\} { 
								p=0;
								q=0;
								while(yytext[p]!='{') p++;
								p++;
								while(yytext[p]!='}') 
								{
									yylval.stringVal[q]=yytext[p];
									p++;
									q++;
								};
								yylval.stringVal[q]=0;
								return ASMBLOCK;
							};

[a-zA-Z][a-zA-Z0-9]* 	{ strncpy(yylval.stringVal,yytext,NAMESIZE); yylval.stringVal[NAMESIZE-1]=0; return NAME; };
[0-9]+ 	{ yylval.longVal=atoi(yytext); return LONG; };
0x[0-9a-fA-F]+ 	{ yylval.longVal=axtoi(yytext); return LONG; };
0b[01]+ 	{ yylval.longVal=abtoi(yytext); return LONG; };
\/\/[a-zA-Z0-9\t ]+\n ;
.	return (int)yytext[0];


%%
